import "antd/es/button/style";
import _Button from "antd/es/button";

var __awaiter = this && this.__awaiter || function (thisArg, _arguments, P, generator) {
  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : new P(function (resolve) {
        resolve(result.value);
      }).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

import * as React from "react";
const {
  useState,
  useEffect
} = React;
export default function SButton({
  label,
  type,
  handler,
  loading = false,
  props
}) {
  const [btnLoading, setBtnLoading] = useState(loading);
  useEffect(() => {
    setBtnLoading(loading);
  }, [loading]);

  const clickHandler = () => __awaiter(this, void 0, void 0, function* () {
    if (!handler) return;

    try {
      setBtnLoading(true);
      yield handler();
    } finally {
      setBtnLoading(false);
    }
  });

  return React.createElement(_Button, Object.assign({
    loading: btnLoading,
    onClick: clickHandler,
    type: type
  }, props), label);
}