import "antd/es/form/style";
import _Form from "antd/es/form";
import "antd/es/card/style";
import _Card from "antd/es/card";

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from "react";
import { isFn, isPromise } from "../utils/tool";
import renderOptions from "../lib/renderOptions";
import SButton from "./SButton";
import compMap from "../SCompMap/compMap";
const {
  useState
} = React;
const defaultItemWidth = {
  RangePicker: 400
};
export default function SFilter({
  initialData = {},
  filters,
  formProps = {},
  searchBtnHandler,
  buttons = [],
  onChange: formChange,
  updateFormData,
  searchLoading
}) {
  const [formData, setFormData] = useState(Object.assign({}, initialData));
  const [itemChildren, setItemChildren] = useState({});
  const requiredParams = [];

  const filterItemChange = (v, key, onChange) => {
    if (v && v.target) v = v.target.value;
    const res = Object.assign({}, formData, {
      [key]: v
    });
    setFormData(res);
    updateFormData(res);
    if (isFn(onChange)) onChange(v);
    if (isFn(formChange)) formChange(res);
  };

  return React.createElement(_Card, null, React.createElement(_Form, Object.assign({
    layout: "inline"
  }, formProps), filters.map(({
    Comp,
    type = "Input",
    label,
    key,
    formItemProps,
    render,
    onChange,
    options,
    style = {},
    props,
    required
  }) => {
    if (required) requiredParams.push(key);
    style.width = defaultItemWidth[type] || 300;
    const Item = compMap[type];
    const Children = render && render();

    if (!options && isPromise(Children) && !itemChildren[key]) {
      Children.then(Child => {
        setItemChildren(Object.assign({}, itemChildren, {
          [key]: Child
        }));
      }).catch(err => {
        console.log(`get ${key} options error :` + err);
      });
    }

    return Item ? React.createElement(_Form.Item, Object.assign({
      required: required,
      key: label,
      label: label
    }, formItemProps), Comp ? isFn(Comp) ? React.createElement(Comp, null) : Comp : React.createElement(Item, Object.assign({
      allowClear: !required,
      value: formData[key],
      onChange: e => {
        filterItemChange(e, key, onChange);
      },
      style: style
    }, props), options ? renderOptions(options) : isPromise(Children) ? itemChildren[key] : Children)) : null;
  }), React.createElement(_Form.Item, null, React.createElement(SButton, {
    handler: searchBtnHandler,
    label: "Search",
    type: "primary",
    loading: searchLoading,
    props: {
      htmlType: "submit"
    }
  }), buttons.map(_a => {
    var {
      Comp,
      label,
      key
    } = _a,
        rest = __rest(_a, ["Comp", "label", "key"]);

    if (Comp) {
      return isFn(Comp) ? React.createElement(Comp, {
        key: key
      }) : Comp;
    }

    return React.createElement(SButton, Object.assign({
      key: label,
      label: label
    }, rest));
  }))));
}