import "antd/es/table/style";
import _Table from "antd/es/table";
import "antd/es/card/style";
import _Card from "antd/es/card";
import * as React from "react";
export default function STable({
  tableData = [],
  tableColumns,
  tableProps = {},
  pageNum = 1,
  pageSize = 10,
  totalNum = 0,
  pageChange,
  loading
}) {
  return React.createElement(_Card, {
    style: {
      marginTop: 20
    }
  }, React.createElement(_Table, Object.assign({
    loading: loading,
    rowKey: tableProps.rowKey,
    dataSource: tableData,
    columns: tableColumns,
    pagination: {
      current: pageNum,
      pageSize: pageSize,
      total: totalNum,
      onChange: pageChange,
      showTotal: (total, range) => `${range[0]}-${range[1]} of ${total} items`
    }
  }, tableProps)));
}