var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import * as React from "react";
const {
  useState,
  useEffect
} = React;
import compMap from "../SCompMap/compMap";
import { isFn } from "../utils/tool";
export default function (filters, tableColumns, openModal) {
  const [columns, setColumns] = useState([]);
  useEffect(() => {
    let res = [];
    filters.forEach(({
      label,
      key,
      inTable = true,
      tableRender
    }) => {
      if (inTable) {
        res.push({
          title: label,
          dataIndex: key,
          key,
          render: tableRender
        });
      }
    });
    res = res.concat(tableColumns.map(_a => {
      var {
        label,
        key,
        render,
        modalRender,
        modalProps,
        type,
        hide
      } = _a,
          rest = __rest(_a, ["label", "key", "render", "modalRender", "modalProps", "type", "hide"]);

      const Comp = compMap[type];

      if (Comp) {
        render = (_text, record, _index) => {
          if (isFn(hide) && hide(record)) return null;
          return React.createElement(Comp, Object.assign({
            onClick: () => {
              openModal(record, modalRender, modalProps);
            }
          }, rest));
        };

        key = label;
      }

      return {
        title: label,
        dataIndex: key,
        key,
        render
      };
    }));
    setColumns(res);
  }, [filters, tableColumns]);
  return columns;
}